<html>
<head>
<title>OgreD3D11HardwarePixelBuffer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a2df88393729a3f182c00116937c948.html">Direct3D11</a>      </li>
      <li class="navelem"><a class="el" href="dir_80c990f15d364d52e4690b415f060ae9.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreD3D11HardwarePixelBuffer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreD3D11HardwarePixelBuffer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __D3D11PIXELBUFFER_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __D3D11PIXELBUFFER_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D11Prerequisites_8h.html">OgreD3D11Prerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwarePixelBuffer_8h.html">OgreHardwarePixelBuffer.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D11Driver_8h.html">OgreD3D11Driver.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 
<a name="l00037"></a><a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html">00037</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html">D3D11HardwarePixelBuffer</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1HardwarePixelBuffer.html" title="Specialisation of HardwareBuffer for a pixel buffer.">HardwarePixelBuffer</a>
<a name="l00038"></a>00038     {
<a name="l00039"></a>00039     <span class="keyword">protected</span>:
<a name="l00041"></a>00041         <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a97d54e4b53547d75a5fa08ee722c4ce3" title="Lock a box.">lockImpl</a>(<span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> lockBox,  <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> options);
<a name="l00042"></a>00042 
<a name="l00044"></a>00044         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a22deacab1a9e63a2bded8f74be15ad4a" title="Unlock a box.">unlockImpl</a>(<span class="keywordtype">void</span>);
<a name="l00045"></a>00045 
<a name="l00047"></a><a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a6701830b6d42e965b216e15e19e22acc">00047</a>         <a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp; <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a6701830b6d42e965b216e15e19e22acc" title="D3DDevice pointer.">mDevice</a>;
<a name="l00048"></a>00048 
<a name="l00049"></a><a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a6ff5a159af4ac5c4ae270e337985646d">00049</a>         <a class="code" href="classOgre_1_1D3D11Texture.html">D3D11Texture</a> * <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a6ff5a159af4ac5c4ae270e337985646d">mParentTexture</a>;
<a name="l00050"></a><a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#afd0bc6c5495424d20959ac772da5353e">00050</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#afd0bc6c5495424d20959ac772da5353e">mSubresourceIndex</a>;
<a name="l00051"></a>00051 
<a name="l00052"></a>00052         <span class="comment">// if the usage is static - alloc at lock then use device UpdateSubresource when unlock and free memory</span>
<a name="l00053"></a><a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a3459676342136520338c461db7d790c2">00053</a>         <a class="code" href="namespaceOgre.html#aa258bf39b19d5814a79d6533763e02ba">int8</a> * <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a3459676342136520338c461db7d790c2">mDataForStaticUsageLock</a>; 
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#aad6da446f558b0fea05478d175d44bbe">00055</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#aad6da446f558b0fea05478d175d44bbe">mFace</a>;
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a01d89ede00e4020f682766dc4917c7f9">00057</a>         <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a01d89ede00e4020f682766dc4917c7f9">mLockBox</a>;
<a name="l00058"></a><a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a21e3d615aea0a6110e749a5f93a3ff11">00058</a>         <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a21e3d615aea0a6110e749a5f93a3ff11">mCurrentLock</a>;
<a name="l00059"></a>00059 
<a name="l00060"></a>00060         D3D11_BOX <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a0a0f3e37138a60d3f3df4cdabaef085a">OgreImageBoxToDx11Box</a>(<span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> &amp;inBox) <span class="keyword">const</span>;
<a name="l00061"></a>00061 
<a name="l00063"></a>00063         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#af61eedf42eb4ee7a511b9f74f757e5c9" title="Util functions to convert a D3D locked box to a pixel box.">fromD3DLock</a>(<a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;rval, <span class="keyword">const</span> DXGI_MAPPED_RECT &amp;lrect);
<a name="l00064"></a>00064 
<a name="l00066"></a><a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#ae96b30d0e2fafcd377e0f20523f8c505">00066</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;RenderTexture*&gt;::type</a> <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#ae96b30d0e2fafcd377e0f20523f8c505" title="Render targets.">SliceTRT</a>;
<a name="l00067"></a><a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#ab5f7869f8d83b6f45db784f160c175e0">00067</a>         <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#ae96b30d0e2fafcd377e0f20523f8c505" title="Render targets.">SliceTRT</a> <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#ab5f7869f8d83b6f45db784f160c175e0">mSliceTRT</a>;
<a name="l00068"></a>00068     <span class="keyword">public</span>:
<a name="l00069"></a>00069         <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#af0c86f663a38936565c8526fa99c1852">D3D11HardwarePixelBuffer</a>(<a class="code" href="classOgre_1_1D3D11Texture.html">D3D11Texture</a> * parentTexture, <a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp; device, <span class="keywordtype">size_t</span> subresourceIndex,
<a name="l00070"></a>00070             <span class="keywordtype">size_t</span> width, <span class="keywordtype">size_t</span> height, <span class="keywordtype">size_t</span> depth, <span class="keywordtype">size_t</span> face, <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> format, <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage);
<a name="l00071"></a>00071 
<a name="l00073"></a>00073         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a829af326c8d276cf750aedbc0a7938b1">blit</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwarePixelBufferSharedPtr.html" title="Shared pointer implementation used to share pixel buffers.">HardwarePixelBufferSharedPtr</a> &amp;src, <span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> &amp;srcBox, <span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> &amp;dstBox);
<a name="l00074"></a>00074 
<a name="l00076"></a>00076         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#ae6f1442db70221c769539f22d2915fda">blitFromMemory</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;src, <span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> &amp;dstBox);
<a name="l00077"></a>00077 
<a name="l00079"></a>00079         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#af51365d1529bf44d290c240906b7bed7">blitToMemory</a>(<span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> &amp;srcBox, <span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;dst);
<a name="l00080"></a>00080 
<a name="l00082"></a>00082         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#aef747afc351b1b0fd6342be4c285d626" title="Internal function to update mipmaps on update of level 0.">_genMipmaps</a>();
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085         <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a3adf2b25d3b0360a5176d2cb6dd15722">~D3D11HardwarePixelBuffer</a>();
<a name="l00086"></a>00086 
<a name="l00088"></a>00088         <a class="code" href="classOgre_1_1RenderTexture.html" title="This class represents a RenderTarget that renders to a Texture.">RenderTexture</a> *<a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a00af3808ecc36639351291657e7393eb" title="Get rendertarget for z slice.">getRenderTarget</a>(<span class="keywordtype">size_t</span> zoffset);
<a name="l00089"></a>00089 
<a name="l00091"></a><a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a95580550437c8ddfcf7426b1571d5ab0">00091</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a95580550437c8ddfcf7426b1571d5ab0" title="Notify TextureBuffer of destruction of render target.">_clearSliceRTT</a>(<span class="keywordtype">size_t</span> zoffset)
<a name="l00092"></a>00092         {
<a name="l00093"></a>00093             <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#ab5f7869f8d83b6f45db784f160c175e0">mSliceTRT</a>.size() &gt; zoffset)
<a name="l00094"></a>00094             {
<a name="l00095"></a>00095                 <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#ab5f7869f8d83b6f45db784f160c175e0">mSliceTRT</a>[zoffset] = 0;
<a name="l00096"></a>00096             }
<a name="l00097"></a>00097         }
<a name="l00098"></a>00098 
<a name="l00099"></a>00099         <a class="code" href="classOgre_1_1D3D11Texture.html">D3D11Texture</a> * <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a83cc557920c6dab014a9c10e8bf4d795">getParentTexture</a>() <span class="keyword">const</span>;
<a name="l00100"></a>00100         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#a621591d9eb10efba419e93ca42189bc7">getSubresourceIndex</a>() <span class="keyword">const</span>;
<a name="l00101"></a>00101         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1D3D11HardwarePixelBuffer.html#aa88c87ac9a674d9de992a7cb5c9f5569">getFace</a>() <span class="keyword">const</span>;
<a name="l00102"></a>00102     };
<a name="l00103"></a>00103 };
<a name="l00104"></a>00104 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
